## rustc-1.62 1.62.1%2Bdfsg1

=== src/test/run-make-fulldeps/link-arg/Makefile ===
-include ../tools.mk
RUSTC_FLAGS = -C link-arg="-lfoo" -C link-arg="-lbar" --print link-args

all:
	$(RUSTC) $(RUSTC_FLAGS) empty.rs | $(CGREP) lfoo lbar

=== src/test/run-make/raw-dylib-stdcall-ordinal/Makefile ===
# Test the behavior of #[link(.., kind = "raw-dylib")], #[link_ordinal], and alternative calling conventions on i686 windows.

# only-x86
# only-windows

-include ../../run-make-fulldeps/tools.mk

all:
	$(call COMPILE_OBJ,"$(TMPDIR)"/exporter.obj,exporter.c)
ifdef IS_MSVC
	$(CC) "$(TMPDIR)"/exporter.obj exporter-msvc.def -link -dll -out:"$(TMPDIR)"/exporter.dll
else
	$(CC) "$(TMPDIR)"/exporter.obj exporter-gnu.def -shared -o "$(TMPDIR)"/exporter.dll
endif
	$(RUSTC) --crate-type lib --crate-name raw_dylib_test lib.rs
	$(RUSTC) --crate-type bin driver.rs -L "$(TMPDIR)"
	"$(TMPDIR)"/driver > "$(TMPDIR)"/actual_output.txt

ifdef RUSTC_BLESS_TEST
	cp "$(TMPDIR)"/actual_output.txt expected_output.txt
else
	$(DIFF) expected_output.txt "$(TMPDIR)"/actual_output.txt
endif

## rustc-1.62 1.62.1+dfsg1

=== src/test/run-make-fulldeps/libtest-json/Makefile ===
-include ../tools.mk

# Test expected libtest's JSON output

OUTPUT_FILE_DEFAULT := $(TMPDIR)/libtest-json-output-default.json
OUTPUT_FILE_STDOUT_SUCCESS := $(TMPDIR)/libtest-json-output-stdout-success.json

all: f.rs validate_json.py output-default.json output-stdout-success.json
	$(RUSTC) --test f.rs
	RUST_BACKTRACE=0 $(call RUN,f) -Z unstable-options --test-threads=1 --format=json > $(OUTPUT_FILE_DEFAULT) || true
	RUST_BACKTRACE=0 $(call RUN,f) -Z unstable-options --test-threads=1 --format=json --show-output > $(OUTPUT_FILE_STDOUT_SUCCESS) || true

	cat $(OUTPUT_FILE_DEFAULT) | "$(PYTHON)" validate_json.py
	cat $(OUTPUT_FILE_STDOUT_SUCCESS) | "$(PYTHON)" validate_json.py

	# Normalize the actual output and compare to expected output file
	cat $(OUTPUT_FILE_DEFAULT) | sed 's/"exec_time": [0-9.]*/"exec_time": $$TIME/' | diff output-default.json -
	cat $(OUTPUT_FILE_STDOUT_SUCCESS) | sed 's/"exec_time": [0-9.]*/"exec_time": $$TIME/' | diff output-stdout-success.json -

=== src/test/run-make-fulldeps/lto-empty/Makefile ===
-include ../tools.mk

all: cdylib-fat cdylib-thin

cdylib-fat:
	$(RUSTC) lib.rs -C lto=fat -C opt-level=3 -C incremental=$(TMPDIR)/inc-fat
	$(RUSTC) lib.rs -C lto=fat -C opt-level=3 -C incremental=$(TMPDIR)/inc-fat

cdylib-thin:
	$(RUSTC) lib.rs -C lto=thin -C opt-level=3 -C incremental=$(TMPDIR)/inc-thin
	$(RUSTC) lib.rs -C lto=thin -C opt-level=3 -C incremental=$(TMPDIR)/inc-thin

=== src/test/run-make/emit-path-unhashed/Makefile ===
-include ../../run-make-fulldeps/tools.mk

OUT=$(TMPDIR)/emit

# --emit KIND=PATH should not affect crate hash vs --emit KIND
all: $(OUT)/a/libfoo.rlib $(OUT)/b/libfoo.rlib $(OUT)/c/libfoo.rlib \
		$(TMPDIR)/libfoo.rlib
	$(RUSTC) -Zls $(TMPDIR)/libfoo.rlib > $(TMPDIR)/base.txt
	$(RUSTC) -Zls $(OUT)/a/libfoo.rlib > $(TMPDIR)/a.txt
	$(RUSTC) -Zls $(OUT)/b/libfoo.rlib > $(TMPDIR)/b.txt
	$(RUSTC) -Zls $(OUT)/c/libfoo.rlib > $(TMPDIR)/c.txt

	diff $(TMPDIR)/base.txt $(TMPDIR)/a.txt
	diff $(TMPDIR)/base.txt $(TMPDIR)/b.txt

	# Different KIND parameters do affect hash.
	# diff exits 1 on difference, 2 on trouble
	diff $(TMPDIR)/base.txt $(TMPDIR)/c.txt ; test "$$?" -eq 1

# Default output name
$(TMPDIR)/libfoo.rlib: foo.rs
	$(RUSTC) --emit link foo.rs

# Output named with -o
$(OUT)/a/libfoo.rlib: foo.rs
	mkdir -p $(OUT)/a
	$(RUSTC) --emit link -o $@ foo.rs

# Output named with KIND=PATH
$(OUT)/b/libfoo.rlib: foo.rs
	mkdir -p $(OUT)/b
	$(RUSTC) --emit link=$@ foo.rs

# Output multiple kinds
$(OUT)/c/libfoo.rlib: foo.rs
	mkdir -p $(OUT)/c
	$(RUSTC) --emit link=$@,metadata foo.rs

=== src/test/run-make/emit-shared-files/Makefile ===
-include ../../run-make-fulldeps/tools.mk

INVOCATION_ONLY = $(TMPDIR)/invocation-only
TOOLCHAIN_ONLY = $(TMPDIR)/toolchain-only
ALL_SHARED = $(TMPDIR)/all-shared

all: invocation-only toolchain-only all-shared

invocation-only:
	$(RUSTDOC) -Z unstable-options --emit=invocation-specific --output $(INVOCATION_ONLY) --resource-suffix=-xxx --theme y.css --extend-css z.css x.rs
	[ -e $(INVOCATION_ONLY)/search-index-xxx.js ]
	[ -e $(INVOCATION_ONLY)/settings.html ]
	[ -e $(INVOCATION_ONLY)/x/all.html ]
	[ -e $(INVOCATION_ONLY)/x/index.html ]
	[ -e $(INVOCATION_ONLY)/theme-xxx.css ] # generated from z.css
	! [ -e $(INVOCATION_ONLY)/storage-xxx.js ]
	! [ -e $(INVOCATION_ONLY)/SourceSerif4-It.ttf.woff2 ]

	# FIXME: this probably shouldn't have a suffix
	[ -e $(INVOCATION_ONLY)/y-xxx.css ]
	# FIXME: this is technically incorrect (see `write_shared`)
	! [ -e $(INVOCATION_ONLY)/main-xxx.js ]

toolchain-only:
	$(RUSTDOC) -Z unstable-options --emit=toolchain-shared-resources --output $(TOOLCHAIN_ONLY) --resource-suffix=-xxx --extend-css z.css x.rs
	[ -e $(TOOLCHAIN_ONLY)/storage-xxx.js ]
	! [ -e $(TOOLCHAIN_ONLY)/SourceSerif4-It.ttf.woff2 ]
	! [ -e $(TOOLCHAIN_ONLY)/search-index-xxx.js ]
	! [ -e $(TOOLCHAIN_ONLY)/x/index.html ]
	! [ -e $(TOOLCHAIN_ONLY)/theme.css ]

	[ -e $(TOOLCHAIN_ONLY)/main-xxx.js ]
	! [ -e $(TOOLCHAIN_ONLY)/y-xxx.css ]

all-shared:
	$(RUSTDOC) -Z unstable-options --emit=toolchain-shared-resources,unversioned-shared-resources --output $(ALL_SHARED) --resource-suffix=-xxx --extend-css z.css x.rs
	[ -e $(ALL_SHARED)/storage-xxx.js ]
	[ -e $(ALL_SHARED)/SourceSerif4-It.ttf.woff2 ]
	! [ -e $(ALL_SHARED)/search-index-xxx.js ]
	! [ -e $(ALL_SHARED)/settings.html ]
	! [ -e $(ALL_SHARED)/x ]
	! [ -e $(ALL_SHARED)/src ]
	! [ -e $(ALL_SHARED)/theme.css ]

	[ -e $(ALL_SHARED)/main-xxx.js ]
	! [ -e $(ALL_SHARED)/y-xxx.css ]

=== src/test/run-make/incr-prev-body-beyond-eof/Makefile ===
# ignore-none no-std is not supported
# ignore-nvptx64-nvidia-cuda FIXME: can't find crate for `std`

include ../../run-make-fulldeps/tools.mk

# Tests that we don't ICE during incremental compilation after modifying a
# function span such that its previous end line exceeds the number of lines
# in the new file, but its start line/column and length remain the same.

SRC=$(TMPDIR)/src
INCR=$(TMPDIR)/incr

all:
	mkdir $(SRC)
	mkdir $(INCR)
	cp a.rs $(SRC)/main.rs
	$(RUSTC) -C incremental=$(INCR) $(SRC)/main.rs --target $(TARGET)
	cp b.rs $(SRC)/main.rs
	$(RUSTC) -C incremental=$(INCR) $(SRC)/main.rs --target $(TARGET)

=== src/test/run-make/static-pie/Makefile ===
-include ../../run-make-fulldeps/tools.mk

# only-x86_64
# only-linux
# ignore-gnux32

# How to manually run this
# $ ./x.py test --target x86_64-unknown-linux-[musl,gnu] src/test/run-make/static-pie

all: test-clang test-gcc

test-%:
	if ./check_$*_version.sh; then\
		${RUSTC} -Clinker=$* -Clinker-flavor=gcc --target ${TARGET} -C target-feature=+crt-static test-aslr.rs; \
		! readelf -l $(call RUN_BINFILE,test-aslr) | $(CGREP) INTERP; \
		readelf -l $(call RUN_BINFILE,test-aslr) | $(CGREP) DYNAMIC; \
		$(call RUN,test-aslr) --test-aslr; \
	fi

=== debian/changelog ===
rustc-1.62 (1.62.1+dfsg1-1ubuntu4) lunar; urgency=medium

  * Allow to build out-of-tree Rust kernel modules (LP: #2011355):
    - debian/patches/ubuntu-use-serde_json-for-target-spec-json.patch
    - debian/patches/ubuntu-make-debug_triple-depend-on-target-json-file-content.patch

 -- Andrea Righi <andrea.righi@canonical.com>  Sat, 11 Mar 2023 20:14:30 +0000

rustc-1.62 (1.62.1+dfsg1-1ubuntu3) lunar; urgency=medium

  * Rebuild using rustc-1.62 as compiler

 -- Simon Chopin <schopin@ubuntu.com>  Wed, 01 Feb 2023 10:28:51 +0100

rustc-1.62 (1.62.1+dfsg1-1ubuntu2) lunar; urgency=medium

  * Branch off into a version-specific source package:
    - d/control: rename all binary packages
    - install all files into /usr/lib/rust-1.62/ and use versioned symlinks
    - drop the documentation package for now to make things easier

 -- Simon Chopin <schopin@ubuntu.com>  Fri, 02 Dec 2022 09:43:17 +0100

rustc (1.62.1+dfsg1-1ubuntu1) lunar; urgency=medium

  * Merge 1.62.0+dfsg1-1 from Debian unstable
    Remaining changes:
    - Downgrade cargo from rustc Recommends to Suggests to make rustc promotable to
      main.
    - d/control: Add fonts-nanum to the rust-doc deps
    - d/control: Add the rust-doc deps as build-deps for the linkchecker tests
    - Reduce parallelism on all arches other than riscv64 to avoid OOMs
      during build.
    - Explicitly disable LTO
    - Add a self-build autopkgtest
    - Ship the Cargo.lock file along with the compiler to identify which crates
      were bundled in.
    - d/p/ubuntu-fix-crossbeam-CVE-2022-23639.patch: cherry-pick to fix CVE-2022-23639
      amended to also patch the 0.7.2 version of the crate
    - On i386, only build debuginfo for libstd
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
    - Build-Depend on libc6-dbg on armhf, to workaround a crash in ld.so
      during some debuginfo tests
    - Version the Build-Conflict on gdb-minimal as gdb now Provides it
    - Adjust the rustc Breaks/Replaces libstd-rust-dev version to fix an
      upgrade issue
    - Add Build-Depends-Indep: libssl-dev
    - Revert workaround for upstream bug #74786
    - Disable wasm build as build dependencies not currently available in
      Ubuntu.
    - Do not build windows cross compiler.
    - Drop llvm-13 to Suggests for rustc to avoid having to promote it to Ubuntu
      main
    - Add XS-Vendored-Sources-Rust field support
      Needed an extra patch due to rustc being a multi-crate source package.
    Integrated in Debian:
    - d/p/ubuntu-disable-ppc64el-asm-tests.patch: disable tests on power
      and s390x if using asm!()
    - d/p/ubuntu-ignore-arm-doctest.patch: Patch out the bad doctests for the
      instruction_set errors
    Dropped, not needed anymore:
    - d/p/ubuntu-compiletest-fix.patch: Fix compilation with 1.61
  * d/control: Update the vendored sources field

 -- Simon Chopin <schopin@ubuntu.com>  Thu, 24 Nov 2022 09:58:29 +0100

rustc (1.62.1+dfsg1-1) unstable; urgency=medium

  * Upload to unstable
  * Fix armhf build

 -- Fabian Gruenbichler <debian@fabian.gruenbichler.email>  Mon, 31 Oct 2022 14:19:34 +0100

rustc (1.62.1+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release

 -- Fabian Gruenbichler <debian@fabian.gruenbichler.email>  Fri, 28 Oct 2022 11:35:48 +0200

rustc (1.61.0+dfsg1-2) unstable; urgency=medium

  [ Ximin Luo]
  * Improve cross-building documentation

  [ Adrian Bunk ]
  * Disable kernel_user_helpers on armel (duplicate symbols)
  * Increase allowed failures on armel/mips64el/ppc64 (Closes: #1020860)

  [ Fabian Grünbichler ]
  * cherry-pick patches from Ubuntu
  * fix rebuild of 1.61 with 1.61

 -- Fabian Gruenbichler <debian@fabian.gruenbichler.email>  Mon, 10 Oct 2022 20:19:05 +0200

rustc (1.61.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable (Closes: #1020394)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 22 Sep 2022 09:00:21 +0200

rustc (1.61.0+dfsg1-1~exp1ubuntu1) kinetic; urgency=medium

  * Merge 1.61.0+dfsg1-1~exp1 from Debian unstable (LP: #1986648)
    Remaining changes:
    - Downgrade cargo from rustc Recommends to Suggests to make rustc promotable to
      main. (LP: #1966200)
    - d/control: Add fonts-nanum to the rust-doc deps
    - d/control: Add the rust-doc deps as build-deps for the linkchecker tests
    - Reduce parallelism on all arches other than riscv64 to avoid OOMs
      during build.
    - Explicitly disable LTO
    - Add a self-build autopkgtest
    - Ship the Cargo.lock file along with the compiler to identify which crates
      were bundled in.
    - d/p/ubuntu-ignore-arm-doctest.patch: Patch out the bad doctests for the
      instruction_set errors
    - d/p/ubuntu-fix-crossbeam-CVE-2022-23639.patch: cherry-pick to fix CVE-2022-23639
      amended to also patch the 0.7.2 version of the crate
    - On i386, only build debuginfo for libstd
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
    - Build-Depend on libc6-dbg on armhf, to workaround a crash in ld.so
      during some debuginfo tests
    - Version the Build-Conflict on gdb-minimal as gdb now Provides it
    - Adjust the rustc Breaks/Replaces libstd-rust-dev version to fix an
      upgrade issue
    - Add Build-Depends-Indep: libssl-dev
    - Revert workaround for upstream bug #74786
    - Disable wasm build as build dependencies not currently available in
      Ubuntu.
    - Do not build windows cross compiler.
    - Drop llvm-13 to Suggests for rustc to avoid having to promote it to Ubuntu
      main
    - Add XS-Vendored-Sources-Rust field support
      Needed an extra patch due to rustc being a multi-crate source package.
    - d/p/ubuntu-disable-ppc64el-asm-tests.patch: disable tests on power
      and s390x if using asm!()
  * d/control: Update the vendored sources field
  * d/p/ubuntu-compiletest-fix.patch: Fix compilation with 1.61

 -- Simon Chopin <schopin@ubuntu.com>  Mon, 19 Sep 2022 18:41:53 +0200



=== debian/control ===
Source: rustc-1.62
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 13),
 dh-cargo (>= 28ubuntu1~),
 dpkg-dev (>= 1.17.14),
 python3:native,
 cargo:native (>= 0.40.0)      <!pkg.rustc.dlstage0>,
 rustc-1.62,
 llvm-14-dev:native,
 llvm-14-tools:native,
 libllvm14 (>= 1:14.0.0),
 cmake (>= 3.0) | cmake3,
# needed by some vendor crates
 pkg-config,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# Resources loaded from the docs, checked by linkchecker
 libjs-jquery <!nocheck>,
 libjs-highlight.js <!nocheck>,
 libjs-mathjax <!nocheck>,
 fonts-open-sans <!nocheck>,
 fonts-font-awesome <!nocheck>,
 fonts-nanum <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
 libc6-dbg [armhf],
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
 clang-14:native,
 libssl-dev,
Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
Standards-Version: 4.2.1
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust
XS-Vendored-Sources-Rust: addr2line@0.16.0, adler@0.2.3, adler@1.0.2, ahash@0.7.4, aho-corasick@0.7.18, ammonia@3.2.0, annotate-snippets@0.8.0, ansi_term@0.12.1, anyhow@1.0.56, array_tool@1.0.3, arrayvec@0.7.2, askama@0.11.0, askama_derive@0.11.0, askama_escape@0.10.2, askama_shared@0.12.0, atty@0.2.14, autocfg@1.1.0, bitflags@1.3.2, block-buffer@0.10.2, block-buffer@0.7.3, block-padding@0.1.5, bstr@0.2.13, byte-tools@0.3.1, bytecount@0.6.2, byteorder@1.3.4, bytes@1.0.1, camino@1.0.7, cargo-platform@0.1.2, cargo_metadata@0.14.2, cc@1.0.73, cfg-if@0.1.10, cfg-if@1.0.0, chalk-derive@0.80.0, chalk-engine@0.80.0, chalk-ir@0.80.0, chalk-solve@0.80.0, chrono@0.4.19, clap@2.34.0, clap@3.1.1, clap_complete@3.1.1, cmake@0.1.44, colored@2.0.0, compiler_builtins@0.1.71, compiletest_rs@0.7.1, cpufeatures@0.2.1, crc32fast@1.3.2, crossbeam-channel@0.5.4, crossbeam-deque@0.8.1, crossbeam-epoch@0.9.8, crossbeam-utils@0.8.8, crypto-common@0.1.2, cstr@0.2.8, ctor@0.1.15, datafrog@2.0.1, derive-new@0.5.8, diff@0.1.12, digest@0.10.2, digest@0.8.1, dirs-next@2.0.0, dirs-sys-next@0.1.2, dirs-sys@0.3.6, dirs@2.0.2, dissimilar@1.0.3, dlmalloc@0.2.3, either@1.6.1, elasticlunr-rs@2.3.9, ena@0.14.0, env_logger@0.7.1, env_logger@0.8.4, expect-test@1.2.2, fake-simd@0.1.2, fallible-iterator@0.2.0, filetime@0.2.16, fixedbitset@0.2.0, flate2@1.0.23, fluent-bundle@0.15.2, fluent-langneg@0.13.0, fluent-syntax@0.11.0, fnv@1.0.7, form_urlencoded@1.0.1, fortanix-sgx-abi@0.3.3, fs-err@2.5.0, futf@0.1.4, futures-channel@0.3.19, futures-core@0.3.19, futures-executor@0.3.19, futures-io@0.3.19, futures-macro@0.3.19, futures-sink@0.3.19, futures-task@0.3.19, futures-util@0.3.19, futures@0.3.19, generic-array@0.12.4, generic-array@0.14.4, getopts@0.2.21, getrandom@0.1.14, getrandom@0.2.0, gimli@0.25.0, gimli@0.26.1, glob@0.3.0, globset@0.4.5, gsgdt@0.1.2, handlebars@4.1.0, hashbrown@0.11.2, hashbrown@0.12.0, heck@0.3.3, hermit-abi@0.1.19, hermit-abi@0.2.0, hex@0.4.2, html5ever@0.26.0, humantime@1.3.0, humantime@2.0.1, idna@0.2.3, if_chain@1.0.0, ignore@0.4.17, indexmap@1.8.1, indoc@1.0.3, instant@0.1.12, intl-memoizer@0.5.1, intl_pluralrules@7.0.1, itertools@0.10.3, itoa@1.0.1, jobserver@0.1.24, jsonpath_lib@0.2.6, lazy_static@1.4.0, libc@0.2.125, libloading@0.7.3, libm@0.1.4, lock_api@0.4.7, log@0.4.16, lzma-sys@0.1.16, mac@0.1.1, macro-utils@0.1.3, maplit@1.0.2, markup5ever@0.11.0, matchers@0.1.0, matches@0.1.9, md-5@0.10.0, mdbook@0.4.18, measureme@10.0.0, memchr@2.4.1, memmap2@0.2.1, memoffset@0.6.5, minifier@0.0.43, minimal-lexical@0.2.1, miniz_oxide@0.4.0, miniz_oxide@0.5.1, miow@0.3.7, new_debug_unreachable@1.0.4, nom@7.1.0, num-integer@0.1.43, num-traits@0.2.12, num_cpus@1.13.1, object@0.26.2, object@0.28.4, odht@0.3.1, once_cell@1.10.0, opaque-debug@0.2.3, opener@0.5.0, os_str_bytes@6.0.0, output_vt100@0.1.2, packed_simd_2@0.3.4, parking_lot@0.11.2, parking_lot@0.12.0, parking_lot_core@0.8.5, parking_lot_core@0.9.2, pathdiff@0.2.1, percent-encoding@2.1.0, perf-event-open-sys@1.0.1, pest@2.1.3, pest_derive@2.1.0, pest_generator@2.1.3, pest_meta@2.1.3, petgraph@0.5.1, phf@0.10.1, phf_codegen@0.10.0, phf_generator@0.10.0, phf_shared@0.10.0, pin-project-lite@0.2.8, pin-utils@0.1.0, pkg-config@0.3.18, polonius-engine@0.13.0, ppv-lite86@0.2.8, precomputed-hash@0.1.1, pretty_assertions@0.7.2, proc-macro-error-attr@1.0.4, proc-macro-error@1.0.4, proc-macro-hack@0.5.19, proc-macro2@1.0.37, psm@0.1.16, pulldown-cmark@0.9.1, punycode@0.4.1, quick-error@1.2.3, quick-error@2.0.0, quine-mc_cluskey@0.2.4, quote@1.0.18, rand@0.7.3, rand@0.8.5, rand_chacha@0.2.2, rand_chacha@0.3.0, rand_core@0.5.1, rand_core@0.6.2, rand_hc@0.2.0, rand_xorshift@0.2.0, rand_xoshiro@0.6.0, rayon-core@1.9.2, rayon@1.5.2, redox_syscall@0.2.13, redox_users@0.4.0, regex-automata@0.1.10, regex-syntax@0.6.25, regex@1.5.5, remove_dir_all@0.5.3, rls-data@0.19.1, rls-span@0.5.3, rustc-demangle@0.1.21, rustc-hash@1.1.0, rustc-rayon-core@0.3.2, rustc-rayon@0.3.2, rustc-semver@1.1.0, rustc_tools_util@0.2.0, rustfix@0.5.1, rustfix@0.6.0, rustversion@1.0.5, ryu@1.0.9, same-file@1.0.6, scoped-tls@1.0.0, scopeguard@1.1.0, self_cell@0.10.2, semver@1.0.7, serde@1.0.136, serde_derive@1.0.136, serde_json@1.0.79, sha-1@0.10.0, sha-1@0.8.2, sha2@0.10.1, sharded-slab@0.1.4, shell-escape@0.1.5, shlex@1.0.0, siphasher@0.3.3, slab@0.4.2, smallvec@1.8.0, snap@1.0.5, stable_deref_trait@1.2.0, stacker@0.1.14, string_cache@0.8.3, string_cache_codegen@0.5.2, strsim@0.10.0, strsim@0.8.0, structopt-derive@0.4.18, structopt@0.3.25, strum@0.18.0, strum_macros@0.18.0, syn@1.0.91, synstructure@0.12.6, tar@0.4.37, tempfile@3.2.0, tendril@0.4.1, term@0.6.1, term@0.7.0, termcolor@1.1.2, termize@0.1.1, tester@0.9.0, textwrap@0.11.0, textwrap@0.14.2, thiserror-impl@1.0.30, thiserror@1.0.30, thorin-dwp@0.2.0, thread_local@1.1.4, time@0.1.43, tinystr@0.3.4, tinyvec@1.5.1, tinyvec_macros@0.1.0, tokio@1.8.4, toml@0.5.7, topological-sort@0.1.0, tracing-attributes@0.1.20, tracing-core@0.1.26, tracing-log@0.1.2, tracing-subscriber@0.3.11, tracing-tree@0.2.0, tracing@0.1.34, type-map@0.4.0, typenum@1.12.0, ucd-parse@0.1.8, ucd-trie@0.1.3, unic-char-property@0.9.0, unic-char-range@0.9.0, unic-common@0.9.0, unic-emoji-char@0.9.0, unic-langid-impl@0.9.0, unic-langid-macros-impl@0.9.0, unic-langid-macros@0.9.0, unic-langid@0.9.0, unic-ucd-version@0.9.0, unicase@2.6.0, unicode-bidi@0.3.7, unicode-normalization@0.1.19, unicode-script@0.5.3, unicode-security@0.0.5, unicode-segmentation@1.9.0, unicode-width@0.1.8, unicode-xid@0.2.2, unicode_categories@0.1.1, unified-diff@0.2.1, unindent@0.1.7, url@2.2.2, utf-8@0.7.5, valuable@0.1.0, vec_map@0.8.2, version_check@0.9.4, walkdir@2.3.2, wasi@0.11.0+wasi-snapshot-preview1, wasi@0.9.0+wasi-snapshot-preview1, winapi-i686-pc-windows-gnu@0.4.0, winapi-util@0.1.5, winapi-x86_64-pc-windows-gnu@0.4.0, winapi@0.3.9, windows-sys@0.34.0, windows_aarch64_msvc@0.34.0, windows_i686_gnu@0.34.0, windows_i686_msvc@0.34.0, windows_x86_64_gnu@0.34.0, windows_x86_64_msvc@0.34.0, xattr@0.2.2, xz2@0.1.6, yaml-rust@0.3.5, yansi-term@0.1.2

Package: rustc-1.62
Architecture: any
Multi-Arch: allowed
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
 libstd-rust-1.62-dev (= ${binary:Version}),
 gcc, libc-dev, binutils (>= 2.26)
Suggests:
# lld and clang are needed for wasm compilation
# llvm is needed for llvm-dwp for -C split-debuginfo=packed
 cargo (>= 0.63.0~~), cargo (<< 0.64.0~~),
 llvm-14,lld-14, clang-14,
Replaces: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
Breaks: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
Description: Rust systems programming language
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.

Package: libstd-rust-1.62
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Rust standard libraries
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries, built as dylibs,
 needed to run dynamically-linked Rust programs (-C prefer-dynamic).

Package: libstd-rust-1.62-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
 libstd-rust-1.62 (= ${binary:Version}),
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains development files for the standard Rust libraries,
 needed to compile Rust programs. It may also be installed on a system
 of another host architecture, for cross-compiling to this architecture.

Package: rust-1.62-gdb
Architecture: all
Depends: gdb, ${misc:Depends}
Suggests: gdb-doc
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (gdb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking gdb on rust binaries.

Package: rust-1.62-lldb
Architecture: all
# When updating, also update rust-lldb.links
Depends: lldb-14, ${misc:Depends}, python3-lldb-14
Replaces: rustc (<< 1.1.0+dfsg1-1)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# The build regressed back when LTO was systematized in Ubuntu.
# This should be periodically revisited.
export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control
# Version of /usr/bin/rustc
LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')

include /usr/share/dpkg/buildflags.mk
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export CARGO_HOME = $(CURDIR)/debian/cargo

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
# for dh_install substitution variable
export DEB_HOST_RUST_TYPE

# for dh_install substitution variable
export RUST_LONG_VERSION
export RUST_VERSION

DEB_DESTDIR := $(CURDIR)/debian/tmp

# Use system LLVM (comment out to use vendored LLVM)
LLVM_VERSION = 14
OLD_LLVM_VERSION = 13
# Make it easier to test against a custom LLVM
ifneq (,$(LLVM_DESTDIR))
LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
export LD_LIBRARY_PATH
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq ($(DEB_HOST_ARCH),riscv64)
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NJOBS := -j 4 
endif
endif
RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py $(NJOBS)
RUSTBUILD_FLAGS = --stage 2 --config debian/config.toml --on-fail env
# rust-tidy depends on lots of modules that we strip out of the build.
# it also tries to access the network for some reason. so just disable it.
RUSTBUILD_TEST = $(RUSTBUILD) test --no-fail-fast --exclude src/tools/tidy
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

# https://github.com/rust-lang/rust/issues/89744
# TODO: remove when we update cargo to 1.55 / 0.56
# upstream bug still exists and is under investigation, but is hidden by newer cargo
export CARGO_PROFILE_RELEASE_BUILD_OVERRIDE_OPT_LEVEL=0

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	debian/update-version.sh $$oldver $$newver $(RUST_LONG_VERSION) $(CARGO_NEW)

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
DOWNLOAD_BOOTSTRAP := false
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_DESTDIR))
        RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
        DOWNLOAD_BOOTSTRAP := true
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS := false
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  BUILD_DOCS := false
endif
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
  BUILD_DOCS := false
endif

BUILD_WASM := false

BUILD_WINDOWS := false

MAKE_OPTIMISATIONS := true
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  MAKE_OPTIMISATIONS := false
endif

VERBOSITY_SUB := $(words $(filter terse,$(DEB_BUILD_OPTIONS)))
VERBOSITY_ADD := $(words $(filter verbose,$(DEB_BUILD_OPTIONS)))
VERBOSITY := $(shell expr 2 + $(VERBOSITY_ADD) - $(VERBOSITY_SUB))

ifeq ($(shell test $(VERBOSITY) -ge 3; echo $$?),0)
  export DH_VERBOSE=1
endif

ifeq ($(shell test $(VERBOSITY) -le 0; echo $$?),0)
  export DH_QUIET=1
.SILENT:
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/bootstrap/bootstrap.pyc \
	src/bootstrap/__pycache__ \
	src/etc/__pycache__/

# Try to work around #933045
ifneq (,$(filter $(DEB_BUILD_ARCH), mips mipsel))
  SYSTEM_WORKAROUNDS += export MALLOC_ARENA_MAX=1;
endif

%:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

.PHONY: .dbg-windows
.dbg-windows:
	@echo host=$(DEB_BUILD_ARCH) target=$(DEB_HOST_ARCH) BUILD_WINDOWS=$(BUILD_WINDOWS) WINDOWS_ARCH=$(WINDOWS_ARCH)

.PHONY: build
build:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

override_dh_clean:
	# Upstream contains a lot of these
	dh_clean -XCargo.toml.orig

BOOTSTRAP_COMPILER = "/usr/bin/rustc-$(RUST_VERSION)"

debian/config.toml: debian/config.toml.in debian/rules
	u="$(DEB_VERSION_UPSTREAM)"; \
	if [ "$$u" != "$${u%~beta.*+dfsg*}" ]; then channel="beta"; \
	else channel="stable"; fi; \
	m4  -DRELEASE_CHANNEL="$$channel" \
		-DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
		-DDEB_BUILD_GNU_TYPE="$(DEB_BUILD_GNU_TYPE)" \
		-DDEB_HOST_GNU_TYPE="$(DEB_HOST_GNU_TYPE)" \
		-DDEB_TARGET_GNU_TYPE="$(DEB_TARGET_GNU_TYPE)" \
		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
		-DVERBOSITY="$(VERBOSITY)" \
		-DLLVM_DESTDIR="$(LLVM_DESTDIR)" \
		-DLLVM_VERSION="$(LLVM_VERSION)" \
		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
		-DRUST_VERSION="$(RUST_VERSION)" \
		-DBOOTSTRAP_COMPILER="$(BOOTSTRAP_COMPILER)" \
		"$<" > "$@"
	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \
	  then sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"; fi
# Work around low-memory (32-bit) architectures: https://github.com/rust-lang/rust/issues/45854
# i386 and x32 fail to mmap rustc_driver when building rustdoc in >1.60
ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel i386 mips mipsel powerpc powerpcspe x32))
	sed -i -e 's/^debuginfo-level = .*/debuginfo-level = 0/g' "$@"
endif
